#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <unistd.h>

#define KEY 1984
#define SIZE 1024

int main(){
	int shmid;
	char *shmbuf;
	struct shmid_ds buf;

	shmid = shmget(KEY, SIZE, IPC_CREAT|0666);
	printf("shmid is %d\n", shmid);
	if(shmid == -1){
		fprintf(stderr,"shmget failed errno:%d %s\n",errno, strerror(errno));
		return -1;
	}
	
	if(shmctl(shmid, IPC_STAT, &buf) == -1){
		fprintf(stderr,"shmctl stat failed errno:%d %s\n",errno, strerror(errno));
		return -1;
	}
	printf("shm_segsz = %d bytes\n", buf.shm_segsz);
	printf("shm_cpid = %d\n", buf.shm_cpid);
	printf("shm_lpid = %d\n", buf.shm_lpid);

	shmbuf = shmat(shmid, NULL, SHM_RDONLY);
	printf("read out:\n%s\n",shmbuf);

	if(shmctl(shmid, IPC_RMID, NULL) == -1){
		fprintf(stderr,"shmctl rm failed errno:%d %s\n",errno, strerror(errno));
		return -1;
	}

	return 0;
}
